# Contributing

We welcome community contributions. Feel free to use GitHub mechanisms or Discord to:

- report bugs and undesirable application behavior
- request and discuss new features
- discuss application usage and documentation
- build plugins in your own repository and ask us to promote them
- contribute to the project via the Pull Request Process below

## Pull Request Process

1. Make sure to reference an open GitHub issue with your pull request. If a related issue does
   not exist, make one. 
2. Target the `develop` branch with your pull request. This means you'll probably want to make 
   your changes on the `develop` branch of your fork.
3. Make sure your changes don't break the tests or the build. The tests/build will run
   automatically when you open your pull request. You can also run the tests locally.
4. If you are changing core library functionality or a core plugin, try to include some tests
   that demonstrate that the change did not break anything.
5. Please reach out if you have any questions or hesitations. 